; The name of the installer
Name "CoJaK"

; The file to write
OutFile "web\Install CoJaK.exe"

; The default installation directory
InstallDir "$PROGRAMFILES\CoJaK"

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "SOFTWARE\CoJaK" "Install_Dir"

; The text to prompt the user to enter a directory
ComponentText "This will install the CoJaK on your computer. Select which parts you want installed."

; The text to prompt the user to enter a directory
DirText "Choose a directory to install in to:"

;--------------------------------

; The stuff to install
Section "CoJaK (required)"
	
	SectionIn RO
	
	; Set output path to the installation directory.
	SetOutPath $INSTDIR
	
	; Put files there
	File "license.txt"
	File "CoJaK.exe"
	File "cojak-config.txt"
	File "help.html"
	File /r lib\
	
	; Write the installation path into the registry
	WriteRegStr HKLM "SOFTWARE\CoJaK" "Install_Dir" "$INSTDIR"
	
	; Write the uninstall keys for Windows
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\CoJaK" "DisplayName" "CoJaK (remove only)"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\CoJaK" "UninstallString" '"$INSTDIR\Uninstall.exe"'
	WriteUninstaller "Uninstall.exe"
	
SectionEnd
	
; optional section (can be disabled by the user)
Section "Chinese/Japanese/Korean Dictionary"
	
	SetOutPath $INSTDIR
	File /r index\
	
SectionEnd

; optional section (can be disabled by the user)
Section "Start Menu Shortcuts"
	
	CreateDirectory "$SMPROGRAMS\CoJaK"
	CreateShortCut "$SMPROGRAMS\CoJaK\Uninstall.lnk" "$INSTDIR\Uninstall.exe" "" "$INSTDIR\Uninstall.exe" 0
	CreateShortCut "$SMPROGRAMS\CoJaK\Font Configuration.lnk" "$INSTDIR\cojak-config.txt" "" "$INSTDIR\cojak-config.txt" 0
	CreateShortCut "$SMPROGRAMS\CoJaK\Documentation.lnk" "$INSTDIR\help.html" "" "$INSTDIR\CoJaK.exe" 0
	CreateShortCut "$SMPROGRAMS\CoJaK\CoJaK.lnk" "$INSTDIR\CoJaK.exe" "" "$INSTDIR\CoJaK.exe" 0
	
SectionEnd

;--------------------------------

; Uninstaller

UninstallText "This will uninstall CoJaK. Press next to continue."

; Uninstall section

Section "Uninstall"
	
	; remove registry keys
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\CoJaK"
	DeleteRegKey HKLM "SOFTWARE\CoJaK"
	
	; remove directories used
	RMDir /r "$SMPROGRAMS\CoJaK"
	RMDir /r "$INSTDIR"
	
SectionEnd