// CoJak: The CJK Oracular Assistant
// Copyright (C) 2003 by Tal Liron
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

package gnu.cojak;

import java.util.*;
import java.io.*;

public class ChineseWordIterator implements Iterator
{
	//
	// Construction
	//
	
	public ChineseWordIterator( File file ) throws IOException
	{
		reader = new BufferedReader( new InputStreamReader( new FileInputStream( file ), "Big5" ), 1048576 ); // 2^20
		prepareNext();
	}
	
	//
	// Iterator
	//
	
	public boolean hasNext()
	{
		return hasNext;
	}
	
	public Object next()
	{
		try
		{
			return chineseWord;
		}
		finally
		{
			prepareNext();
		}
	}
	
	public void remove()
	{
	}
	
	///////////////////////////////////////////////////////////////////////////////////////
	// Private
	
	private boolean hasNext = true;
	private BufferedReader reader;
	private ChineseWord chineseWord;
	
	private void prepareNext()
	{
		try
		{
			chineseWord = new ChineseWord();
			String line = "#";
			int hanziEnd, pinyinStart, pinyinEnd;
			while( line.charAt( 0 ) == '#' )
			{
				line = reader.readLine();
				if( line == null )
				{
					// EOF
					hasNext = false;
					return;
				}
			}
			hanziEnd = line.indexOf( ' ' );
			pinyinStart = line.indexOf( '[', hanziEnd + 1 );
			pinyinEnd = line.indexOf( ']', pinyinStart + 1 );
			chineseWord.chineseHanzi = line.substring( 0, hanziEnd );
			chineseWord.mandarinPinyin = line.substring( pinyinStart + 1, pinyinEnd );
			chineseWord.english = line.substring( pinyinEnd + 2 );
		}
		catch( IOException x )
		{
			hasNext = false;
		}
	}
}
